#!/usr/bin/python
# -*- coding: UTF-8 -*-

############################################################################
#                                                                          #
#  Utilitaire de configuration du support pour bacula                      #
#  génère le fichier /etc/bacula/typesupport.conf                          #
#                                                                          #
#  licence GPL Eole                                                        #
#                                                                          #
#  Klaas TJEBBES klaas.tjebbes@ac-dijon.fr                                 # 
#                                                                          #
############################################################################

#from sys import sys.argv, exc_info, sys.exit, path
import sys, os
#Le PYTHONPATH n'est pas récupéré dans un sudo par apache
sys.path.append('/usr/share/eole/')
from cfgparse import ConfigParser
from getopt import getopt, GetoptError



class typeSupport:
    def __init__(self):
        self.fich = '/etc/bacula/typesupport.conf'
        if not os.path.isfile(self.fich): file(self.fich, 'w').write('')

    def liste(self):
        try:
            c = ConfigParser()
            c.add_file(self.fich)
            self.support = c.add_option('Storage').get().lower()
            if self.support == 'file':
                self.support = 'distant'
                self.modifSupport(self.support)
            return self.support
        except:
            return None
    
    def modifSupport(self, support):
        try:
            c = ConfigParser()
            f = c.add_file(self.fich)
            f.set_option('Storage', support)
            f.write(self.fich)
            return True
        except:
            return False

def main():
    """
    """
    try:
        options, args = getopt(sys.argv[1:],'s:hl',
        ['support=',
        'help',
        'liste'])

    except GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
#        sys.exit("l'option -%s est inconnue ou nécessite un argument" % er_msg[er_msg.index('-')+1])
        sys.exit("l'option -%s est inconnue ou nécessite un argument" % er_msg.split(' ')[1])

    sup = typeSupport()
    liste_sup = ['usb', 'bande', 'distant']
    for (opt,val) in options:
        # quel support
        if (opt == '-s') or (opt == '--support'):
            support = val.lower()
            if support not in liste_sup:
                print 'Support "%s" inconnu'%support
                return
            sup.modifSupport(support)
            print sup.liste()
        #listing
        elif (opt == '-l') or (opt == '--liste'):
            print sup.liste()
        else:
            print """Usage :
%s -l --liste
%s -s SUPPORT --support SUPPORT (usb, bande, distant)
"""%(sys.argv[0],sys.argv[0])

if __name__ == "__main__":
    main()

